#include <avr/io.h>
#include <avr/interrupt.h>  /* for sei() */
#include <util/delay.h>     /* for _delay_ms() */
#include <avr/pgmspace.h>   /* required by usbdrv.h */
#include "usbdrv.h"
#define SDBIT0 0
#define SDBIT1 1
#define SDBIT2 2
#define SDBIT3 3
#define SDBIT4 4
#define SDBIT5 5
#define SDBIT6 6
#define SDBIT7 7
#define RQ_SET_LED_FIRST  0
#define RQ_SET_LED_SECOND 1
uint8_t scanData[8];
uint8_t i = 0 ;

/* ------------------------------------------------------------------------- */
/* ----------------------------- USB interface ----------------------------- */
/* ------------------------------------------------------------------------- */
void Display()
{
        for(i=0;i<8;i++)
        {
                _delay_ms(0.02);
                PORTC = 0b00000000;
                PORTB = 0b00000000;
                PORTD &= 0b10011100;
                switch (i)
                {
                        case 0:
                                PORTB = 0b00000001;
                        break ;
                        case 1:
                                PORTB = 0b00000100;
                        break;
                        case 2:
                                PORTB = 0b00000010;
                        break ;
                        case 3:
                                PORTB = 0b00001000;
                        break ;
                        case 4:
                                PORTC = 0b00010000;
                        break ;
                        case 5:
                                PORTC = 0b00000100;
                        break ;
                        case 6:
                                PORTC = 0b00100000;
                        break ;
                        case 7:
                                PORTC = 0b00001000;
                        break ;
                }
                PORTC |= (((scanData[i]>>SDBIT0) & 0b00000001) << PC0) | (((scanData[i]>>SDBIT1) & 0b00000001) << PC1);
                PORTB |= (((scanData[i]>>SDBIT2) & 0b00000001) << PB5) | (((scanData[i]>>SDBIT3) & 0b00000001) << PB4);
                PORTD |= (((scanData[i]>>SDBIT4) & 0b00000001) << PD6) | (((scanData[i]>>SDBIT5) & 0b00000001) << PB5) | (((scanData[i]>>SDBIT6) & 0b00000001) << PD0) | (((scanData[i]>>SDBIT7) & 0b00000001) << PD1);

        }                       
}

usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
    usbRequest_t *rq = (void *)data;
    
    if (rq->bRequest == RQ_SET_LED_FIRST)
    {
        scanData[0] = rq->wIndex.bytes[0];
        scanData[1] = rq->wIndex.bytes[1];
        scanData[2] = rq->wValue.bytes[0];
        scanData[3] = rq->wValue.bytes[1];
                    
        return 0;
    }
    
    if(rq->bRequest == RQ_SET_LED_SECOND)
    {
        scanData[4] = rq->wIndex.bytes[0];
        scanData[5] = rq->wIndex.bytes[1];
        scanData[6] = rq->wValue.bytes[0];
        scanData[7] = rq->wValue.bytes[1];
        
        return 0;
    }

    return 0;   /* default for not implemented requests: return no data back to host */
}

/* ------------------------------------------------------------------------- */

int main(void)
{
    usbInit();

    PORTD = 0b00000000;
    PORTB = 0b00000000;
    PORTC = 0b00000000;
    DDRD |= 0b01100011;
    DDRB |= 0b00111111;
    DDRC |= 0b00111111;

    scanData[0] = 0b11111111;
    scanData[1] = 0b11111111;
    scanData[2] = 0b11111111;
    scanData[3] = 0b11111111;
    scanData[4] = 0b11111111;
    scanData[5] = 0b11111111;
    scanData[6] = 0b11111111;
    scanData[7] = 0b11111111;

    /* enforce re-enumeration, do this while interrupts are disabled! */
    usbDeviceDisconnect();
    _delay_ms(300);
    usbDeviceConnect();

    /* enable global interrupts */
    sei();

    /* main event loop */
    for(;;)
    {
        Display();
        usbPoll();
    }

    return 0;
}

/* ------------------------------------------------------------------------- */
